'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _encBase = require('crypto-js/enc-base64');

var _encBase2 = _interopRequireDefault(_encBase);

var _md2 = require('crypto-js/md5');

var _md3 = _interopRequireDefault(_md2);

var _sha2 = require('crypto-js/sha512');

var _sha3 = _interopRequireDefault(_sha2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Replace non-alphanumeric and padding characters in the Base-64 alphabet to
// comply with most password policies.
function customBase64(str) {
  return str.replace(/\+/g, '9').replace(/\//g, '8').replace(/=/g, 'A');
}

// Compute hexadecimal hash and convert it to Base-64.
/*!
 * SuperGenPass library
 * https://github.com/chriszarate/supergenpass-lib
 * https://chriszarate.github.com/supergenpass/
 * License: GPLv2
 */

function customBase64Hash(str, hashFunction) {
  var result = hashFunction(str).toString(_encBase2.default);
  return customBase64(result);
}

var hashFunctions = {
  md5: function md5(str) {
    return customBase64Hash(str, _md3.default);
  },
  sha512: function sha512(str) {
    return customBase64Hash(str, _sha3.default);
  }
};

// Return a hash function for SGP to use.
function hash(method) {
  // Is user supplies a function, use it and assume they will take of any
  // encoding (Base-64 or otherwise).
  if (typeof method === 'function') {
    return method;
  }

  if (hashFunctions.hasOwnProperty(method)) {
    return hashFunctions[method];
  }

  throw new Error('Could not resolve hash function, received ' + (typeof method === 'undefined' ? 'undefined' : (0, _typeof3.default)(method)) + '.');
}

exports.default = hash;